/************************************************************************/
/*									*/
/*	Quick Monitor  -  Vista Sidebar Gadget  -  Settings		*/
/*									*/
/*	Copyright (C) 2009  by  David Wilson				*/
/*									*/
/*	Last Edit  -  02 Dec 2009					*/
/*									*/
/************************************************************************/

var locator,refresher,wmiService;

var dskRefPerfs,netRefPerfs;

var blackColor = "#000000";
var dimmedColor = "#A0A0A0";

System.Gadget.onSettingsClosing = SettingsClosing;

function SettingsOpening()
{
    var dskDrive,netInterface;
    var perfsEnumerator,perf;
    var selected,option;
    
    /* Initialise WMI */

    locator = new ActiveXObject("WbemScripting.SWbemLocator");
    refresher = new ActiveXObject("WbemScripting.SWbemRefresher");  /* for fast access to Perf data */
    wmiService = locator.ConnectServer("localhost", "root\\CIMV2");

    dskRefPerfs = refresher.AddEnum(wmiService,"Win32_PerfFormattedData_PerfDisk_LogicalDisk").ObjectSet;
    netRefPerfs = refresher.AddEnum(wmiService,"Win32_PerfFormattedData_Tcpip_NetworkInterface").ObjectSet;

    refresher.Refresh();

    /* CPU Settings */

    cpuParamPicker.selectedIndex = System.Gadget.Settings.read("cpuParam");
    
    cpuCycle.value = System.Gadget.Settings.read("cpuCycle");
    
    /* Memory Settings */
    
    memParamPicker.selectedIndex = System.Gadget.Settings.read("memParam");
    
    memFaults.value = System.Gadget.Settings.read("memFaults");
    
    /* Disk Settings */

    dskParamPicker.selectedIndex = System.Gadget.Settings.read("dskParam");
    
    dskDrive = System.Gadget.Settings.read("dskDrive");
    
    perfsEnumerator = new Enumerator(dskRefPerfs);
    dskDrivePicker.options.length = 0;
    for(; !perfsEnumerator.atEnd(); perfsEnumerator.moveNext())
    {
        perf = perfsEnumerator.item();
        if (perf.Name.substr(1,1) == ":")
        {
           selected = (dskDrive == perf.Name);
           option = new Option(perf.Name,perf.Name,false,selected)
           dskDrivePicker.options[dskDrivePicker.options.length] = option;
        }
    }
    delete perfsEnumerator;

    dskRead.value = System.Gadget.Settings.read("dskRead");

    dskWrite.value = System.Gadget.Settings.read("dskWrite");

    /* Network Settings */

    netParamPicker.selectedIndex = System.Gadget.Settings.read("netParam");
    
    netInterface = System.Gadget.Settings.read("netInterface");
    
    perfsEnumerator = new Enumerator(netRefPerfs);
    netInterfacePicker.options.length = 0;
    for(; !perfsEnumerator.atEnd(); perfsEnumerator.moveNext())
    {
        perf = perfsEnumerator.item();
        selected = (netInterface == perf.Name);
        option = new Option(perf.Name,perf.Name,false,selected)
        netInterfacePicker.options[netInterfacePicker.options.length] = option;
    }
    delete perfsEnumerator;

    netDownload.value = System.Gadget.Settings.read("netDownload");

    netUpload.value = System.Gadget.Settings.read("netUpload");
  
    /* Display Settings */

    cpuColorPicker.selectedIndex = System.Gadget.Settings.read("cpuColor");
    
    memColorPicker.selectedIndex = System.Gadget.Settings.read("memColor");
    
    dskColorPicker.selectedIndex = System.Gadget.Settings.read("dskColor");
    
    netColorPicker.selectedIndex = System.Gadget.Settings.read("netColor");
    
    titleStylePicker.selectedIndex = System.Gadget.Settings.read("titleStyle");
    
    graphStylePicker.selectedIndex = System.Gadget.Settings.read("graphStyle");
    
    /* Set Initial State */
    
    cpuParamChange();
    memParamChange();
    dskParamChange();
    netParamChange();
}

function cpuParamChange()
{
    if (cpuParamPicker.selectedIndex == 0)
    {
	cpuCycleTitle.style.color = dimmedColor;
	cpuCycle.style.color = dimmedColor;
    }
    else if (cpuParamPicker.selectedIndex == 1)
    {
	cpuCycleTitle.style.color = dimmedColor;
	cpuCycle.style.color = dimmedColor;
    }
    else if (cpuParamPicker.selectedIndex == 2)
    {
	cpuCycleTitle.style.color = blackColor;
	cpuCycle.style.color = blackColor;
    }
    else if (cpuParamPicker.selectedIndex == 3)
    {
	cpuCycleTitle.style.color = dimmedColor;
	cpuCycle.style.color = dimmedColor;
    }
}

function memParamChange()
{
    if (memParamPicker.selectedIndex == 0)
    {
	memFaultsTitle.style.color = blackColor;
	memFaults.style.color = blackColor;
    }
    else if (memParamPicker.selectedIndex == 1)
    {
	memFaultsTitle.style.color = dimmedColor;
	memFaults.style.color = dimmedColor;
    }
    else if (memParamPicker.selectedIndex == 2)
    {
	memFaultsTitle.style.color = dimmedColor;
	memFaults.style.color = dimmedColor;
    }
}

function dskParamChange()
{
    if (dskParamPicker.selectedIndex == 0)
    {
	dskReadTitle.style.color = dimmedColor;
	dskRead.style.color = dimmedColor;
 	dskWriteTitle.style.color = dimmedColor;
 	dskWrite.style.color = dimmedColor;
   }
    else if (dskParamPicker.selectedIndex == 1)
    {
	dskReadTitle.style.color = blackColor;
	dskRead.style.color = blackColor;
	dskWriteTitle.style.color = dimmedColor;
	dskWrite.style.color = dimmedColor;
    }
    else if (dskParamPicker.selectedIndex == 2)
    {
	dskReadTitle.style.color = dimmedColor;
	dskRead.style.color = dimmedColor;
	dskWriteTitle.style.color = blackColor;
	dskWrite.style.color = blackColor;
    }
    else if (dskParamPicker.selectedIndex == 3)
    {
	dskReadTitle.style.color = dimmedColor;
	dskRead.style.color = dimmedColor;
 	dskWriteTitle.style.color = dimmedColor;
 	dskWrite.style.color = dimmedColor;
    }
}

function netParamChange()
{
    if (netParamPicker.selectedIndex == 0)
    {
	netDownloadTitle.style.color = blackColor;
	netDownload.style.color = blackColor;
	netUploadTitle.style.color = dimmedColor;
	netUpload.style.color = dimmedColor;
    }
    else if (netParamPicker.selectedIndex == 1)
    {
	netDownloadTitle.style.color = dimmedColor;
	netDownload.style.color = dimmedColor;
	netUploadTitle.style.color = blackColor;
	netUpload.style.color = blackColor;
    }
}

function SettingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
	/* CPU Settings */
	
	System.Gadget.Settings.write("cpuParam",cpuParamPicker.selectedIndex);
	System.Gadget.Settings.write("cpuCycle",cpuCycle.value);
	
	/* Memory Settings */
	
	System.Gadget.Settings.write("memParam",memParamPicker.selectedIndex);
	System.Gadget.Settings.write("memFaults",memFaults.value);
	
	/* Disk Settings */
	
	System.Gadget.Settings.write("dskParam",dskParamPicker.selectedIndex);
	System.Gadget.Settings.write("dskDrive",dskDrivePicker.value);
	System.Gadget.Settings.write("dskRead",dskRead.value);
	System.Gadget.Settings.write("dskWrite",dskWrite.value);
	
	/* Network Settings */
	
	System.Gadget.Settings.write("netParam",netParamPicker.selectedIndex);
	System.Gadget.Settings.write("netInterface",netInterfacePicker.value);
	System.Gadget.Settings.write("netDownload",netDownload.value);
	System.Gadget.Settings.write("netUpload",netUpload.value);
	 
	/* Display Settings */
	
	System.Gadget.Settings.write("cpuColor",cpuColorPicker.selectedIndex);
	System.Gadget.Settings.write("memColor",memColorPicker.selectedIndex);
	System.Gadget.Settings.write("dskColor",dskColorPicker.selectedIndex);
	System.Gadget.Settings.write("netColor",netColorPicker.selectedIndex);
	System.Gadget.Settings.write("titleStyle",titleStylePicker.selectedIndex);
	System.Gadget.Settings.write("graphStyle",graphStylePicker.selectedIndex);
    }

    event.cancel = false;
}

